library ieee;

use ieee.std_logic_1164.all;


package fa_pckg is
   component full_adder

	port(

		A: in std_logic;
		B: in std_logic;
		Cin: in std_logic;

		S: out std_logic;
		Cout: out std_logic

	);

   end component;
end fa_pckg;

library ieee;

use ieee.std_logic_1164.all;


entity full_adder is

	port(

		A: in std_logic;
		B: in std_logic;
		Cin: in std_logic;

		S: out std_logic;
		Cout: out std_logic

	);

end entity full_adder;

architecture behav of full_adder is

begin

     S <= (A xor B) xor Cin;

     Cout <= (A and B) or ((A xor B) and Cin);


end architecture behav;
