library ieee;

use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

package lu_pckg is

    component logic_unit is

	port(
		y4,y5,y6,y7: in bit;
		L0: in std_logic_vector(7 downto 0);
		L1: in std_logic_vector(7 downto 0);

		T: out std_logic_vector(7 downto 0)
	);
    end component logic_unit;

end package lu_pckg;



library ieee;

use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity logic_unit is

	port(

		y4,y5,y6,y7: in bit;
		L0: in std_logic_vector(7 downto 0);
		L1: in std_logic_vector(7 downto 0);

		T: out std_logic_vector(7 downto 0)
	);

end entity;

architecture behav of logic_unit is

begin

	logic_function:process(y4,y5,y6,y7) is
	
	begin
 	
		if y4 ='1' then
	
			for i in 0 to 7 loop

				T(i)<= L0(i) and L1(i);

			end loop;

		elsif y5 ='1' then

			for i in 0 to 7 loop

				T(i)<= L0(i) or L1(i);

			end loop;

		elsif y6 ='1' then

			for i in 0 to 7 loop

				T(i)<= not L0(i);

			end loop;

		elsif y7 ='1' then

			for i in 0 to 7 loop

				T(i)<= L0(i) xor L1(i);

			end loop;

		end if;
		

	end process logic_function;
	
	
end architecture behav; 
